/*!
 * GeneFullCalendar v1.1.8
 * License: Apache License 2.0
 * Copyright 2016 (C) ITcowork Inc. All Rights Reserved.
 * http://itcowork.co.jp/genexus/genefull/
 */
function GeneFullCalendar()
{
	this.Width;
	this.Height;

	// Setting Values
	this.Language;
	this.WeekNumber;
	this.DefaultDate;
	this.Selectable;
	this.Editable;
	this.Events;
	this.NotClickDates;

	// Event Flags and Value
	this.DayClick;
	this.EventClick;
	this.EventResize;
	this.Prompt;
	this.PromptText;
	this.EventDrop;
	this.DefaultView;

	// Result Values
	this.ResultEvents;

	// Databinding for property DefaultDate
	this.SetDefaultDate = function(data)
	{
		///UserCodeRegionStart:[SetDefaultDate] (do not remove this comment.)
		this.DefaultDate = data;

		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property DefaultDate
	this.GetDefaultDate = function()
	{
		///UserCodeRegionStart:[GetDefaultDate] (do not remove this comment.)
		if (jQuery.isEmptyObject(this.DefaultDate)) {
			return new Date();
		} else {
			return this.replaceAll(this.DefaultDate, "/", "-");
		}
		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property Events
	this.SetEvents = function(data)
	{
		///UserCodeRegionStart:[SetEvents] (do not remove this comment.)
		this.Events = data;
		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property Events
	this.GetEvents = function()
	{
		///UserCodeRegionStart:[GetEvents] (do not remove this comment.)
		return this.Events;
		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property NotClickDates
	this.SetNotClickDates = function(data)
	{
		///UserCodeRegionStart:[SetNotClickDates] (do not remove this comment.)
		this.NotClickDates = data;
		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property NotClickDates
	this.GetNotClickDates = function()
	{
		///UserCodeRegionStart:[GetNotClickDates] (do not remove this comment.)
		return this.NotClickDates;
		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property ResultEvents
	this.SetResultEvents = function(data)
	{
		///UserCodeRegionStart:[SetResultEvents] (do not remove this comment.)
		this.ResultEvents = data;
		///UserCodeRegionEnd: (do not remove this comment.)
	}

	// Databinding for property ResultEvents
	this.GetResultEvents = function()
	{
		///UserCodeRegionStart:[GetResultEvents] (do not remove this comment.)
		return this.ResultEvents;
		///UserCodeRegionEnd: (do not remove this comment.)
	}




	this.show = function()
	{
		///UserCodeRegionStart:[show] (do not remove this comment.)

		// Variable mythis set...
		var mythis = this;

		if (!this.IsPostBack){
			// Set html. Id is [this.ControlName]
			mythis.setHtml('<div id="'+ mythis.ControlName +'"></div>');

			// This Id FullCalendar Set
			$("#" + this.ControlName).each(function(){
				mythis.calendarthis = this;

				$(mythis.calendarthis).fullCalendar({
					header: {
						left: 'prevYear,prev,today,next,nextYear' ,
						center: 'title' ,
						right: 'month,agendaWeek,agendaDay'
					},
					defaultDate: mythis.GetDefaultDate() ,
					selectable: mythis.Selectable,
					selectHelper: false,
					select: function(start, end, jsEvent, view) {
						if(mythis.Prompt == true && $("div.gx-mask").length == 0){
							var title = prompt(mythis.PromptText);
							if (title) {
								var allDay = mythis.allDayCheck(start, end);
								var eventData = {id:0, title:title, start:start, end:end, allDay:allDay, url:""};
								$(mythis.calendarthis).fullCalendar('renderEvent', eventData, true); // stick = true
								mythis.onPro(eventData);
							}
						}
						$(mythis.calendarthis).fullCalendar('unselect');
					},
					dayClick: function(date, jsEvent, view) {
						if(mythis.DayClick == true && mythis.Prompt == false && $("div.gx-mask").length == 0) {
							for (i = 0; i < mythis.NotClickDates.length; i++) {
								if(moment(mythis.NotClickDates[i]).format("YYYY-MM-DD") == date.format("YYYY-MM-DD")){
									return;
								}
							}
							mythis.onDay(date.format());
						}
					},
					eventClick: function(calEvent, jsEvent, view) {
						if(mythis.EventClick == true && $("div.gx-mask").length == 0) {
							mythis.onEve(calEvent);
						}
					},
					eventResize: function(event, delta, revertFunc) {
						if(mythis.EventResize == true && $("div.gx-mask").length == 0) {
							$(mythis.calendarthis).fullCalendar('rerenderEvents');
							mythis.onEveRe(event);
						}
					},
					eventDrop: function(event, delta, revertFunc) {
						if(mythis.EventDrop == true && $("div.gx-mask").length == 0) {
							$(mythis.calendarthis).fullCalendar('rerenderEvents');
							mythis.onEveDro(event);
						}
					},
					viewRender: function(view, element) {
						var startDate = view.start.format();
						var endDate = view.end.format();
						if (mythis.IsPostBack) mythis.onViewChg(startDate,endDate);
					},
					lang: mythis.Language ,
					weekNumbers: mythis.WeekNumbers ,
					editable: mythis.Editable ,
					events: mythis.Events
				});
				$(mythis.calendarthis).fullCalendar( 'changeView', mythis.DefaultView);
			});

			// prevYear ~ nextYear
			$('.fc-prevYear-button,.fc-prev-button,.fc-today-button,.fc-next-button,.fc-nextYear-button').click(function(){
				this.blur();
			});

			$('.fc-prevYear-button,.fc-prev-button,.fc-today-button,.fc-next-button,.fc-nextYear-button').focus(function(){
				if($("div.gx-mask").length > 0) this.blur();
			});

			$('.fc-month-button,.fc-agendaWeek-button,.fc-agendaDay-button').click(function(){
				this.blur();
			});

			$('.fc-month-button,.fc-agendaWeek-button,.fc-agendaDay-button').focus(function(){
				if($("div.gx-mask").length > 0) this.blur();
			});

		}
		///UserCodeRegionEnd: (do not remove this comment.)
	}
	///UserCodeRegionStart:[User Functions] (do not remove this comment.)

	var calendarthis;

	this.onAlert = function(msg)	// GeneXus => UserControl [GeneFullCalendar]
	{
		window.alert(msg);	// Show alert...
	}

	this.getEventDatas = function()	// GeneXus => UserControl [GeneFullCalendar]
	{
		var eventArray = $(this.calendarthis).fullCalendar('clientEvents');
		this.ResultEvents = this.ArrayToResult(eventArray);
		// GeneXus Event Call
		if (typeof(this.getEventDatasResult) == 'function') this.getEventDatasResult();
	}

	this.RenderEvents = function(item)	// GeneXus => UserControl [GeneFullCalendar]
	{
		//$(this.calendarthis).fullCalendar('rerenderEvents');
		$(this.calendarthis).fullCalendar('renderEvent', item, true); // stick = true
	}

	this.RerenderEvent = function()	// GeneXus => UserControl [GeneFullCalendar]
	{
		$(this.calendarthis).fullCalendar('removeEvents');
		for (i = 0; i < this.Events.length; i++) {
			$(this.calendarthis).fullCalendar('renderEvent', this.Events[i], true); // stick = true
		}
		$(this.calendarthis).fullCalendar('rerenderEvents');
	}

	this.onPro = function(date)
	{
		this.ResultEvents = [1];
		this.ResultEvents[0] = this.EventToResult(date);
		// GeneXus Event Call
		if (typeof(this.onPrompt) == 'function') this.onPrompt();
	}

	this.onDay = function(date)
	{
		this.ResultEvents = [1];
		this.ResultEvents[0] = this.DataToResult(0, "", date, "", "", false);
		// GeneXus Event Call
		if (typeof(this.onDayClick) == 'function') this.onDayClick();
	}

	this.onEve = function(event)
	{
		this.ResultEvents = [1];
		this.ResultEvents[0] = this.EventToResult(event);
		// GeneXus Event Call
		if (typeof(this.onEventClick) == 'function') this.onEventClick();
	}

	this.onEveRe = function(event)
	{
		this.ResultEvents = [1];
		this.ResultEvents[0] = this.EventToResult(event);
		// GeneXus Event Call
		if (typeof(this.onEventResize) == 'function') this.onEventResize();
	}

	this.onEveDro = function(event)
	{
		this.ResultEvents = [1];
		this.ResultEvents[0] = this.EventToResult(event);
		// GeneXus Event Call
		if (typeof(this.onEventDrop) == 'function') this.onEventDrop();
	}

	this.onViewChg = function(start, end)
	{
		this.ResultEvents = [1];
		this.ResultEvents[0] = this.DataToResult(0, "", start, end, "", false);
		// GeneXus Event Call
		if (typeof(this.onViewChange) == 'function') this.onViewChange();
	}

	this.DataToResult = function(_id, _title, _start, _end, _url, _all)	// Data => Result
	{
		if(!_id) _id = 0;
		if(!_title) _title = "";
		if(!_start) _start = "";
		if(!_end) _end = "";
		if(!_url) _url = "";
		if(!_all) _all = false;

		var json = {
			id: _id,
			title: _title,
			start: _start,
			end: _end,
			url: _url,
			allDay: _all
		};
		// return JSON.stringify(json);		// to String...
		return json;
	}

	this.EventToResult = function(event)	// event => Result
	{
		var _id = 0;
		var _title = "";
		var _start = "";
		var _end = "";
		var _url = "";
		var _all = false;

		if(event.id) _id = event.id;
		if(event.title) _title = event.title;
		if(event.start) _start = event.start.format();
		if(event.end) _end = event.end.format();
		if(event.url) _url = event.url;
		if(event.allDay) _all = event.allDay;

		var json = {
			id: _id,
			title: _title,
			start: _start,
			end: _end,
			url: _url,
			allDay: _all
		};
		return json;
	}

	this.ArrayToResult = function(arr)	// Array => Result
	{
		var jsonArray = [arr.length];
		for (i = 0; i < arr.length; i++) {
			jsonArray[i] = this.EventToResult(arr[i]);
		}
		return jsonArray;
	}

	this.replaceAll = function(expression, org, dest)
	{
		return expression.split(org).join(dest);
	}

	this.allDayCheck = function(start, end)
	{
		var starttime = moment(start).format('MMMM Do YYYY h:mm a');
		var endtime = moment(end).format('h:mm a');
		return !start.hasTime() && !end.hasTime();
	}

	///UserCodeRegionEnd: (do not remove this comment.):
}
